** this version will work only with JAE
program define jae_predict_estar
** first step is to obtain the LL for all six distributions
	qui {
		tempvar std_r1 std_r2 std_s1 std_s2 std_s3
		
		gen double `std_r1'= (r_var-$mean_r1 )/$sig_r1
		gen double `std_r2'= (r_var-$mean_r2 )/$sig_r2
		gen double `std_s1'= (s_var-$mean_s1 )/$sig_s1
		gen double `std_s2'= (s_var-$mean_s2 )/$sig_s2
		gen double `std_s3'= (s_var-$mean_s3 )/$sig_s3
		tempvar lf_2 lf_3 lf_4 lf_5 lf_6 
		*ocal lf_1=(normalden(`_r',`_mean_r1',`_sig_r1'))
		gen double `lf_2'=(1/(2*_pi*$sig_r1 *$sig_s2 *sqrt(1-$rho_r1s2^2))*exp(-1/(2*(1-$rho_r1s2^2))*(`std_r1'^2+`std_s2'^2-2*$rho_r1s2 *`std_r1' *`std_s2' )))
		gen double `lf_3'=(1/(2*_pi*$sig_r1 *$sig_s3 *sqrt(1-$rho_r1s3^2))*exp(-1/(2*(1-$rho_r1s3^2))*(`std_r1'^2+`std_s3'^2-2*$rho_r1s3 *`std_r1' *`std_s3' ))) 
		gen double `lf_4'=(normalden(r_var,$mean_r2 ,$sig_r2 )*normalden(s_var, $mean_s1 , $sig_s1 ))
		gen double `lf_5'=(normalden(r_var,$mean_r2 ,$sig_r2 )*normalden(s_var, $mean_s2 , $sig_s2 ))
		gen double `lf_6'=(normalden(r_var,$mean_r2 ,$sig_r2 )*normalden(s_var, $mean_s3 , $sig_s3 ))  
		
	* income prediction:
	** Generate the income predictors b is for Expected see MRW paper for formulas
		noisily:display "1. Generating within group corrected data"
		gen double y_1 =(r_var+s_var)/2
		gen double y_2 =r_var
		gen double y_3 =r_var
		gen double y_4 =s_var
		gen double y_5 =$mean_e +(s_var-$mean_e -$mean_n )         /(1+$rho_s )  
		gen double y_5b=$mean_e +(s_var-$mean_e -$mean_n )         *(1+$rho_s )*$sig_e^2/((1+$rho_s )^2*$sig_e^2+$sig_n^2          )
		gen double y_6 =$mean_e +(s_var-$mean_e -$mean_n -$mean_w )/(1+$rho_s )
		gen double y_6b=$mean_e +(s_var-$mean_e -$mean_n -$mean_w )*(1+$rho_s )*$sig_e^2/((1+$rho_s )^2*$sig_e^2+$sig_n^2+$sig_w^2)

	**  The next part is to Generate Probabilities
	**  we need 3 sets. pa is the unconditional, pb the posterior probabilities, and pc is the simple assignment to largest prob
		** perhaps a "true" unconditional, so pa01 still unknown
		noisily:display "2. Generating unconditional class probabilities"
		gen double pa0_1=   $pi_r  *   $pi_s 
		gen double pa0_2=   $pi_r  *(1-$pi_s )*(1-$pi_w )
		gen double pa0_3=   $pi_r  *(1-$pi_s )*   $pi_w  
		gen double pa0_4=(1-$pi_r )*   $pi_s             
		gen double pa0_5=(1-$pi_r )*(1-$pi_s )*(1-$pi_w )
		gen double pa0_6=(1-$pi_r )*(1-$pi_s )*   $pi_w  
		
		gen double pa_1=(r_var==s_var)
		gen double pa_2=(r_var!=s_var)*   $pi_r  *(1-$pi_s )*(1-$pi_w )/(1-$pi_r *$pi_s )
		gen double pa_3=(r_var!=s_var)*   $pi_r  *(1-$pi_s )*   $pi_w  /(1-$pi_r *$pi_s )
		gen double pa_4=(r_var!=s_var)*(1-$pi_r )*   $pi_s             /(1-$pi_r *$pi_s )
		gen double pa_5=(r_var!=s_var)*(1-$pi_r )*(1-$pi_s )*(1-$pi_w )/(1-$pi_r *$pi_s )
		gen double pa_6=(r_var!=s_var)*(1-$pi_r )*(1-$pi_s )*   $pi_w  /(1-$pi_r *$pi_s )
		
	** second conditional
		noisily:display "3. Generating conditional/posterior class probabilities."
		tempvar pb2_6
		gen double `pb2_6'=(pa_2*`lf_2'+pa_3*`lf_3'+pa_4*`lf_4'+pa_5*`lf_5'+pa_6*`lf_6')
		gen double pb_1=(r_var==s_var)
		gen double pb_2=pa_2*`lf_2'/`pb2_6'
		gen double pb_3=pa_3*`lf_3'/`pb2_6'
		gen double pb_4=pa_4*`lf_4'/`pb2_6'
		gen double pb_5=pa_5*`lf_5'/`pb2_6'
		gen double pb_6=pa_6*`lf_6'/`pb2_6'
		recode pb_2-pb_6 (.=0)
	**  Two step
		noisily:display "4. Generating two-step class assignment."

		tempvar pc0 pc
		gen byte `pc0'=0
		gen byte `pc'=0
		forvalues i=1/6 {
			replace `pc'=`i' if (pb_`i'>`pc0')
			replace `pc0'=max(`pc0',pb_`i')
		}
		gen byte pc_1=`pc'==1
		gen byte pc_2=`pc'==2
		gen byte pc_3=`pc'==3
		gen byte pc_4=`pc'==4
		gen byte pc_5=`pc'==5
		gen byte pc_6=`pc'==6
	**  with this we get the 4 types of estimations
		noisily:display "5. Generating corrected income levels"

		** unconditional
		gen double ys1 =pa0_1*y_1+pa0_2*y_2+pa0_3*y_3+pa0_4*y_4+pa0_5*y_5 +pa0_6*y_6
		gen double ys1b=pa0_1*y_1+pa0_2*y_2+pa0_3*y_3+pa0_4*y_4+pa0_5*y_5b+pa0_6*y_6b
		** conditional or using posterior probabilities
		gen double ys2 =pb_1*y_1+pb_2*y_2+pb_3*y_3+pb_4*y_4+pb_5*y_5 +pb_6*y_6
		gen double ys2b=pb_1*y_1+pb_2*y_2+pb_3*y_3+pb_4*y_4+pb_5*y_5b+pb_6*y_6b
		** twostep. Based on optimal assignment
		gen double ys3 =pc_1*y_1+pc_2*y_2+pc_3*y_3+pc_4*y_4+pc_5*y_5 +pc_6*y_6
		gen double ys3b=pc_1*y_1+pc_2*y_2+pc_3*y_3+pc_4*y_4+pc_5*y_5b+pc_6*y_6b
	** Here I estimate system wide predictions

	** System Wide prediction. Only for wide
		global mean_r=$pi_r *$mean_e +(1-$pi_r )*$mean_t 
		global mean_s=$mean_e +(1-$pi_s )*($mean_n +$pi_w *$mean_w )
		** VCOV for R and S
		local sig_rr=$pi_r *$sig_e^2+(1-$pi_r )*$sig_t^2+$pi_r *(1-$pi_r )*($mean_e -$mean_t )^2
		local sig_rs=$pi_r *($pi_s +(1-$pi_s )*(1+$rho_s ))*$sig_e^2
		local sig_ss=($pi_s +(1-$pi_s )*(1+$rho_s )^2)*$sig_e^2      ///
					+(1-$pi_s )*$sig_n^2+(1-$pi_s )*$pi_w *$sig_w^2  ///
					+(1-$pi_s )*($pi_s *($mean_n +$pi_w *$mean_w )^2+$pi_w *(1-$pi_w )*$mean_w^2 )     
		** COV R;S with xi ~(e)
		local sig_ey1=$pi_r *$sig_e^2
		local sig_ey2=(1+(1-$pi_s )*$rho_s )*$sig_e^2
		
		matrix SSy=[`sig_rr',`sig_rs' \ ///
				   `sig_rs' , `sig_ss']
		matrix SSey=[`sig_ey1',`sig_ey2']
		matrix SSw=SSey*invsym(SSy)
		
		gen ys4=$mean_e +SSw[1,1]*(r_var-$mean_r )+SSw[1,2]*(s_var-$mean_s )	
		** ξL = 0.22r +0.55s+ 2.85.
		** ξL = b0 * r +c0 * s+ a0.
		
		global a0=SSw[1,1]
		global b0=SSw[1,2]
		global c0=$mean_e - SSw[1,1]*$mean_r - SSw[1,2]*$mean_s
	}
end
