program define jae_table5, rclass

quietly {
	
	tempname tab5
	local p1=   $pi_r  *   $pi_s
	local p2=   $pi_r  *(1-$pi_s )*(1-$pi_w )
	local p3=   $pi_r  *(1-$pi_s )*   $pi_w 
	local p4=(1-$pi_r )*   $pi_s       
	local p5=(1-$pi_r )*(1-$pi_s )*(1-$pi_w )
	local p6=(1-$pi_r )*(1-$pi_s )*   $pi_w 
	* E_Ui
	local b5_1= 1/(1+$rho_s )
	local c5_1=$mean_e-($mean_e +$mean_n)*1/(1+$rho_s )
	local b6_1= 1/(1+$rho_s )
	local c6_1=$mean_e-($mean_e +$mean_n +$mean_w)*1/(1+$rho_s )
	* E_Li
	local b5_2=      (1+$rho_s )*$sig_e ^2 /   ///
			   ((1+$rho_s )^2*$sig_e ^2+$sig_n ^2)
	local b6_2=      (1+$rho_s )*$sig_e ^2 /   ///
			   ((1+$rho_s )^2*$sig_e ^2+$sig_n ^2+$sig_w ^2)
	
	local c5_2=$mean_e -($mean_e +$mean_n)       *(1+$rho_s )*$sig_e ^2 /   ///
								         	((1+$rho_s )^2*$sig_e ^2+$sig_n ^2)
	local c6_2=$mean_e -($mean_e +$mean_n +$mean_w )*(1+$rho_s )*$sig_e ^2 /   ///
											((1+$rho_s )^2*$sig_e ^2+$sig_n ^2+$sig_w ^2) 
	 
	** E_U and E_L
	local au=.5*`p1'+`p2'+`p3'
	local bu=.5*`p1'+`p4'+`b5_1'*`p5'+`b6_1'*`p6'
	local cu=`c5_1'*`p5'+`c6_1'*`p6'

	local al=.5*`p1'+`p2'+`p3'
	local bl=.5*`p1'+`p4'+`b5_2'*`p5'+`b6_2'*`p6'
	local cl=`c5_2'*`p5'+`c6_2'*`p6'

	//////////////////////////////////////////////////
	// Table 5

	matrix `tab5'=[`p1', .5 , .5   , 0    , .5  ,  .5  , 0] \ /// 
				[`p2', 1  ,  0   , 0    ,  1  ,   0  , 0] \ ///
				[`p3', 1  ,  0   , 0    ,  1  ,   0  , 0] \ ///
				[`p4', 0  ,  1   , 0    ,  0  ,   1  , 0] \ ///
				[`p5', 0  ,`b5_1',`c5_1',  0  ,`b5_2',`c5_2'] \ ///
				[`p6', 0  ,`b6_1',`c6_1',  0  ,`b6_2',`c6_2'] \ ///
				[0   ,`au', `bu' , `cu' , `al', `bl' , `cl' ] 
	global b5_2=`b5_2'			
	global b6_2=`b6_2'
	matrix colname `tab5' = pi   a   b   c   a   b   c			
	matrix coleq   `tab5' = " " xihat_Uj xihat_Uj xihat_Uj xihat_j xihat_j xihat_j
	matrix rowname `tab5' = "class1 R1-S1" "class2 R1-S2" "class3 R1-S3" ///
	   "class4 R2-S1" "class5 R2-S2" "class6 R2-S3" "Sums: xihat_U xi_hat"
	
	noi di " "
	noi di "Table 5"

	noi	matrix list `tab5'
	return matrix tab5=`tab5'
	
}
	
end 
